sub btoi32{   #32ビット列を整数に
    ($in) = @_;
    $rev = reverse($in);
    $integer = 0;
    $exp_n = 0;
    if(substr($in,0,1) eq "0"){
	for($i=0;$i<31;$i++){
	    if(substr($rev,$i,1) eq "1"){
		$integer += 2 ** $i;
	    }
	}
    }else{
	for($i=0;$i<31;$i++){
	    if(substr($rev,$i,1) eq "0"){
		$integer += 2 ** $i;
	    }
	}
	$integer += 1;
	$integer *= -1;
    }
    return $integer;
}

sub btod{                #ビット列を浮動小数に
    ($in) = @_;
    $retval = 0;
    $exp = 0;
    $mant = 1;

    $exp_str = reverse(substr($in,1,8));  #exp部の計算
    for($i=0;$i<8;$i++){
	if(substr($exp_str,$i,1) eq "1"){
	    $exp += 2 ** $i;
	}
    }
    $exp -= 127;

    $mant *= 2 ** $exp;
    $mant_str = substr($in,9);            #mantissa部の計算
    for($i=0;$i<23;$i++){
	if(substr($mant_str,$i,1) eq "1"){
	    $mant += 2 ** ($exp-$i-1);
	}
    }

    $retval = $mant;
    if(substr($in,0,1) eq "1"){
	$retval *= -1;
    }
    
    if($exp_str eq "00000000"){
	return (0);
    }else{
	return ($retval);
    }
}

sub dtob{                                 #浮動小数をビット列に
    ($in) = @_ ;
    $in_abs;
    $sign;
    $exp = "";
    $exp_n = 0;
    $mant = "";
    $mant_n = 1;

    if($in < 0){
	$in_abs = (-1) * $in;
	$sign = "1";
    }else{
	$in_abs = $in;
	$sign = "0";
    }

    if($in_abs >= 2){                    #exp部の計算
	while($in_abs >= 2){
	    $exp_n += 1;
	    $in_abs /= 2;
	}
	$exp_n += 127;
	for($i=7;$i>=0;$i--){
	    if($exp_n >= (2 ** $i)){
		$exp_n -= 2 ** $i;
		$exp .= "1";
	    }else{
		$exp .= "0";
	    }
	}
    }elsif($in_abs == 0){
	$exp = "00000000";
    }elsif($in_abs < 1){
	while($in_abs < 1){
	    $exp_n -= 1;
	    $in_abs *= 2;
	}
	$exp_n += 127;
	for($i=7;$i>=0;$i--){
	    if($exp_n >= (2 ** $i)){
		$exp_n -= 2 ** $i;
		$exp .= "1";
	    }else{
		$exp .= "0";
	    }
	}
    }else{                   #1<= $in_abs < 2
	$exp = "01111111";
    }                        #exp部の計算
    
    $in_abs -= 1;            #mantissa部の計算
	for($i=0;$i<23;$i++){
	    if($in_abs >= (2 ** (-$i-1))){
		$mant .= "1";
		$in_abs -= (2 ** (-$i-1));
	    }else{
		$mant .= "0";
	    }
	}

    return ($sign . $exp . $mant);
}

sub main{
    open(IN,"< in_bit.txt");
    open($INPUT,"> input.txt");
    print $INPUT "";   #input.txt初期化
    close($INPUT);
    open($INPUT,">> input.txt");
    $count = 0;
    $count2 = 0;
    while($in_line = <IN>){
	$in1 = btod($in_line);
	
	#print $INPUT $in1 . "\n";
	if(substr($in_line,1,8) != "11111111"){
	    print $INPUT sprintf("%.80f\n",$in1);
	}
	$count += 1;
	if($count % 10000 == 0){
	    print "$count2\n";
	    $count2 += 1;
	}
    }
    close(IN);
    close($INPUT);
}

main;

use Math::Trig;
my $r = 10;
my $s = pi * $r * $r * $r * $r;
print $s,"\n";

$ppp = btod(dtob(pi));
print "$ppp\n";

$bb = "01011110011101101001100101111101";
$bb2 = (btod($bb))/(2**38);
print "$bb\n$bb2\n";
